;##########################################################################
.386
.model flat, stdcall
option casemap:none
title HTTPChk
;##########################################################################
include C:\masm32\include\windows.inc
include C:\masm32\include\kernel32.inc
include C:\masm32\include\user32.inc
include C:\masm32\include\wsock32.inc
includelib C:\masm32\lib\kernel32.lib
includelib C:\masm32\lib\user32.lib
includelib C:\masm32\lib\wsock32.lib
;##########################################################################
szText MACRO Name, Text:VARARG
LOCAL lbl
	jmp	lbl
	Name	db	Text, 0
lbl:
ENDM
m2m MACRO M1, M2
	push	M2
	pop	M1
ENDM
m2mx MACRO M1, M2
	mov	eax, M2
	mov	M1, eax
ENDM
return MACRO RETVALUE
	mov	eax, RETVALUE
	ret
ENDM
iif MACRO condition, if_true, if_false, return
	.if condition
		mov	return, if_true
	.else
		mov	return, if_false
	.endif
ENDM
iifs MACRO condition, if_true, if_false, return
	mov	return, if_false
	.if condition
		mov	return, if_true
	.endif
ENDM
;##########################################################################
;##########################################################################
;##########################################################################
BlockHook	PROTO
ErrorHandler	PROTO C	:DWORD,:DWORD,:DWORD,:DWORD
ExceptionFilter	PROTO	:DWORD
;##########################################################################
.const
	szMsgAbout	db		"HTTPChk", 13, 10
			db		"401 HTTP scanner", 13, 10
			db		"Version 1.0", 13, 10
			db		"Coded by comrade <comrade2k@hotmail.com>", 13, 10
			db		"Web: http://www.comrade64.com/", 13, 10
			db		"     http://comrade.win32asm.com/", 13, 10
			db		"     http://comrade.ownz.com/", 13, 10
			db		"     http://comrade64.cjb.net/", 13, 10, 13, 10
	dwMsgAboutLen	equ		$ - szMsgAbout
	szStatusWork	db		"Working...", 13, 10
	szStatusDone	db		"Done", 13, 10
	szErrorThread	db		13, 10, "Error at %08Xh", 13, 10, "Registers:", 13, 10, "eax = %08Xh ebx = %08Xh ecx = %08Xh", 13, 10, "edx = %08Xh esp = %08Xh ebp = %08Xh", 13, 10, "esi = %08Xh edi = %08Xh", 13, 10, 13, 10, "Recovering...", 13, 10, 0
	szErrorFinal	db		13, 10, "Error at %08Xh", 13, 10, "Quitting...", 13, 10, 0

	szRequest	db		"GET / HTTP/1.0", 13, 10, "Accept: */*", 13, 10, "Connection: Close", 13, 10, 13, 10
;##########################################################################
.data
;##########################################################################
.data?
	hStdOut		dd		?
	hSocket		dd		?
	dwBytesDone	dd		?
	dwTime		dd		?
	szInput		db		32 dup (?)
	szMessage	db		256 dup (?)
	seh		dd		6 dup (?)

	data_start	equ		$
	sin		sockaddr_in	<>
	wsData		WSADATA		<>
	data_size	equ		$ - data_start
;##########################################################################
.code
start:	invoke	GetStdHandle, STD_OUTPUT_HANDLE
	mov	[hStdOut], eax
	invoke	SetUnhandledExceptionFilter, ADDR ExceptionFilter
	invoke	WriteFile, [hStdOut], ADDR szMsgAbout, dwMsgAboutLen, ADDR dwBytesDone, 0
	; install the SEH-frame
	assume	fs:nothing
	push	OFFSET ErrorHandler
	push	FS:[0]
	mov	[seh], esp
	mov	[seh+4], ebp
	mov	[seh+8], ebx
	mov	[seh+12], esi
	mov	[seh+16], edi
	mov	[seh+20], OFFSET @@safe
	mov	FS:[0], esp
	; critical code
	; zero uninitialized data
	push	edi
	xor	eax, eax
	mov	ecx, data_size shr 2
	mov	edi, data_start
	rep	stosd
	IF data_size AND 3
		mov	edi, data_start
		mov	ecx, data_size and 3
		rep	stosb
	ENDIF
	pop	edi
	; parse the command-line
	call	GetCommandLine
	xor	ecx, ecx
	mov	dl, " "
	.if byte ptr [eax]==""""
		mov	dl, """"
	.endif
@@clcz:	cmp	byte ptr [eax], 0
	jne	@@clck
	jmp	@@safe
@@clck:	cmp	byte ptr [eax], dl
	je	@@cldn
	inc	eax
	jmp	@@clcz
@@cldn:	inc	eax
	cmp	dl, """"
	sete	cl
	add	eax, ecx
	push	eax
	; initialize winsock
	invoke	WSAStartup, 101h, ADDR wsData
	invoke	WSASetBlockingHook, ADDR BlockHook
	invoke	WriteFile, [hStdOut], ADDR szStatusWork, sizeof szStatusWork, ADDR dwBytesDone, 0
	call	inet_addr	;invoke	inet_addr, eax
	mov 	[sin.sin_family], AF_INET
	mov	[sin.sin_port], 80 shl 8
	mov	ecx, 255
@@try:	push	ecx
	push	eax
	mov	[sin.sin_addr], eax
	call	GetTickCount
	mov	[dwTime], eax
	invoke	socket, PF_INET, SOCK_STREAM, 0
	mov	[hSocket], eax
	push	eax
	invoke	connect, eax, ADDR sin, sizeof sin
	test	eax, eax
	jnz	@@next
	invoke	send, [hSocket], ADDR szRequest, sizeof szRequest, 0
	inc	eax
	jz	@@next
	invoke	recv, [hSocket], ADDR szInput, sizeof szInput, 0
	inc	eax
	jz	@@next
	.if dword ptr [szInput+9] == " 104"
		invoke	inet_ntoa, dword ptr [sin.sin_addr]
		xor	ecx, ecx
	@@chkz:	cmp	byte ptr [eax+ecx], 0
		je	@@wrip
		inc	ecx
		jmp	@@chkz
	@@wrip:	invoke	WriteFile, [hStdOut], eax, ecx, ADDR dwBytesDone, 0
		invoke	WriteFile, [hStdOut], ADDR szMsgAbout+7, 2, ADDR dwBytesDone, 0
	.endif
@@next:	call	closesocket
	pop	eax
	pop	ecx
	add	eax, 1 shl 24
	dec	ecx
	jnz	@@try
@@safe:	pop	FS:[0]
	call	WSAUnhookBlockingHook
	call	WSACleanup
	invoke	WriteFile, [hStdOut], ADDR szStatusDone, sizeof szStatusDone, ADDR dwBytesDone, 0
	call	ExitProcess
;##########################################################################
BlockHook proc
	call	GetTickCount
	sub	eax, [dwTime]
	cmp	eax, 500
	jl	@@quit
	call	WSACancelBlockingCall
@@quit:	ret
BlockHook endp
;##########################################################################
ErrorHandler proc C lpExcept:DWORD, lpFrame:DWORD, lpContext:DWORD, lpDispatch:DWORD
	mov	eax, [lpExcept]
	mov	ecx, [lpContext]
	invoke	wsprintf, ADDR szMessage, ADDR szErrorThread, [eax][EXCEPTION_RECORD.ExceptionAddress], [ecx][CONTEXT.regEax], [ecx][CONTEXT.regEbx], [ecx][CONTEXT.regEcx], [ecx][CONTEXT.regEdx], [ecx][CONTEXT.regEsp], [ecx][CONTEXT.regEbp], [ecx][CONTEXT.regEsi], [ecx][CONTEXT.regEdi]
	invoke	WriteFile, [hStdOut], ADDR szMessage, eax, ADDR dwBytesDone, 0

	mov	eax, [lpContext]
	m2m	[eax][CONTEXT.regEsp], [seh]
	m2m	[eax][CONTEXT.regEbp], [seh+4]
	m2m	[eax][CONTEXT.regEbx], [seh+8]
	m2m	[eax][CONTEXT.regEsi], [seh+12]
	m2m	[eax][CONTEXT.regEdi], [seh+16]
	m2m	[eax][CONTEXT.regEip], [seh+20]

	xor	eax, eax	; continue execution
	ret
ErrorHandler endp
;##########################################################################
ExceptionFilter proc lpExcept:DWORD
	mov	eax, [lpExcept]
	invoke	wsprintf, ADDR szMessage, ADDR szErrorFinal, [eax][EXCEPTION_RECORD.ExceptionAddress]
	invoke	WriteFile, [hStdOut], ADDR szMessage, eax, ADDR dwBytesDone, 0
	invoke	closesocket, [hSocket]
	invoke	ExitProcess, 0
	xor	eax, eax
	inc	eax		; EXCEPTION_EXECUTE_HANDLER
	ret
ExceptionFilter endp
;##########################################################################
;##########################################################################
;##########################################################################
end start